/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 *
 */


import ApiClient from "../ApiClient";
import PersonDto from '../model/PersonDto';

/**
* PersonController service.
* @module api/PersonControllerApi
* @version v0
*/
export default class PersonControllerApi {

    /**
    * Constructs a new PersonControllerApi. 
    * @alias module:api/PersonControllerApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instance} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }



    /**
     * @param {module:model/PersonDto} personDto 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing HTTP response
     */
    addPersonWithHttpInfo(personDto) {
      let postBody = personDto;
      // verify the required parameter 'personDto' is set
      if (personDto === undefined || personDto === null) {
        throw new Error("Missing the required parameter 'personDto' when calling addPerson");
      }

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = [];
      let contentTypes = ['application/json'];
      let accepts = [];
      let returnType = null;
      return this.apiClient.callApi(
        '/api/person', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * @param {module:model/PersonDto} personDto 
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}
     */
    addPerson(personDto) {
      return this.addPersonWithHttpInfo(personDto)
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


    /**
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with an object containing data of type {@link module:model/PersonDto} and HTTP response
     */
    getPersonWithHttpInfo() {
      let postBody = null;

      let pathParams = {
      };
      let queryParams = {
      };
      let headerParams = {
      };
      let formParams = {
      };

      let authNames = [];
      let contentTypes = [];
      let accepts = ['*/*'];
      let returnType = PersonDto;
      return this.apiClient.callApi(
        '/api/person', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, null
      );
    }

    /**
     * @return {Promise} a {@link https://www.promisejs.org/|Promise}, with data of type {@link module:model/PersonDto}
     */
    getPerson() {
      return this.getPersonWithHttpInfo()
        .then(function(response_and_data) {
          return response_and_data.data;
        });
    }


}
